//-----------------------------------------------------------------
// I-O Signal Assignments.h - Created Fred Foscalina
// These are the I/O signal assignments
//-----------------------------------------------------------------
//
//$Modtime: 1/19/10 2:25p $
//$Revision: 3 $
//$Author: Fredf $ 

#ifndef __I_O_SIGNAL_ASSIGNMENTS_H__	// don't allow multiple loads
#define __I_O_SIGNAL_ASSIGNMENTS_H__

#include "I-O Port M-Variables.h"

// ======================
// Signal defines
// ======================

// ******************************************
// Direct Digital Inputs
// ******************************************
//Direction control for Direct Inputs I/O 00-07
#define ContIn1		M32
#define ContInBuf1	M33

//Direction control for Direct Inputs I/O 08-15
#define ContIn2		M34
#define ContInBuf2	M35

#define I30_0	M0
#define I30_1	M1
#define I30_2	M2
#define I30_3	M3
#define I30_4	M4
#define I30_5	M5
#define I30_6	M6
#define I30_7	M7

#define I31_0	M8
#define I31_1	M9
#define I31_2	M10
#define I31_3	M11
#define I31_4	M12
#define I31_5	M13
#define I31_6	M14
#define I31_7	M15

// new ports for PT8
// INPUTS
#define IDC24_5		I32_2	// M7103
#define IDC24_6		I32_4	// M7105
#define IDC24_3		I33_5	// M7114
#define IDC24_4		I33_6	// M7115
#define IDC24_7		I33_7	// M7116
#define IDC24_11	I32_0	// M7101
#define IDC24_12	I32_6	// M7107
#define IDC24_10	I32_7	// M7108
#define IDC5_20		I32_1	// M7102

#define IDC24_9		I32_5	// M7106
#define IDC24_8		I33_4	// M7113
#define IDC24_0		I34_7	// M7124

#define IDC24_21	HOME_1	// M7521
#define IDC24_22	HOME_2	// M7522
#define IDC24_23	HOME_3	// M7523

#define FAULT_1		M143	// M143
#define FAULT_2		M243	// M243
#define FAULT_3		M343	// M343
#define FAULT_4		M443	// M443

#define IDC24_1		I32_3	// M7104
#define IDC24_2		I36_6	// M7139

#define IDC24_13	I34_0	// M7117
#define IDC24_14	I34_1	// M7118
#define IDC24_15	I34_2	// M7119
#define IDC24_16	I34_3	// M7120
#define IDC24_17	I34_4	// M7121
#define IDC24_18	I34_5	// M7122
#define IDC24_19	I34_6	// M7123

#define I5V_24		I35_0	// M7125
#define I5V_25		I35_1	// M7126
#define I5V_26		I35_2	// M7127
#define I5V_27		I35_3	// M7128
#define I5V_28		I35_4	// M7129
#define I5V_29		I35_5	// M7130
#define I5V_30		I35_6	// M7131
#define I5V_31		I35_7	// M7132

// OUTPUTS
#define ODC5_03		Q40_0	// M7301
#define ODC5_02		Q40_4	// M7305
#define ODC5_05		Q40_6	// M7307
#define ODC5_14		Q41_0	// M7309
#define ODC5_13		Q41_2	// M7311
#define ODC5_00		Q42_4	// M7321
#define ODC5_01		Q42_5	// M7322
#define ODC5_16		Q43_1	// M7326
#define ODC5_08		Q43_2	// M7327
#define ODC5_09		Q43_3	// M7328
#define ODC5_10		Q43_5	// M7330
#define ODC5_11		Q42_1	// M7318
#define ODC5_12		Q42_3	// M7320
#define ODC5_04		Q43_4	// M7329
#define ODC5_06		Q43_6	// M7331
#define ODC5_07		Q43_7	// M7332



#define I32_0	MP1_B0
#define I32_1	MP1_B1
#define I32_2	MP1_B2
#define I32_3	MP1_B3
#define I32_4	MP1_B4
#define I32_5	MP1_B5
#define I32_6	MP1_B6
#define I32_7	MP1_B7

#define I33_0	MP1_B8
#define I33_1	MP1_B9
#define I33_2	MP1_B10
#define I33_3	MP1_B11
#define I33_4	MP1_B12
#define I33_5	MP1_B13
#define I33_6	MP1_B14
#define I33_7	MP1_B15

#define I34_0	MP1_B16
#define I34_1	MP1_B17
#define I34_2	MP1_B18
#define I34_3	MP1_B19
#define I34_4	MP1_B20
#define I34_5	MP1_B21
#define I34_6	MP1_B22
#define I34_7	MP1_B23

#define I35_0	MP1_B24
#define I35_1	MP1_B25
#define I35_2	MP1_B26
#define I35_3	MP1_B27
#define I35_4	MP1_B28
#define I35_5	MP1_B29
#define I35_6	MP1_B30
#define I35_7	MP1_B31

#define I36_0	MP9_B0
#define I36_1	MP9_B1
#define I36_2	MP9_B2
#define I36_3	MP9_B3
#define I36_4	MP9_B4
#define I36_5	MP9_B5
#define I36_6	MP9_B6
#define I36_7	MP9_B7

#define I37_0	MP9_B8
#define I37_1	MP9_B9
#define I37_2	MP9_B10
#define I37_3	MP9_B11
#define I37_4	MP9_B12
#define I37_5	MP9_B13
#define I37_6	MP9_B14
#define I37_7	MP9_B15

#define I38_0	MP9_B16
#define I38_1	MP9_B17
#define I38_2	MP9_B18
#define I38_3	MP9_B19
#define I38_4	MP9_B20
#define I38_5	MP9_B21
#define I38_6	MP9_B22
#define I38_7	MP9_B23

#define I39_0	MP9_B24
#define I39_1	MP9_B25
#define I39_2	MP9_B26
#define I39_3	MP9_B27
#define I39_4	MP9_B28
#define I39_5	MP9_B29
#define I39_6	MP9_B30
#define I39_7	MP9_B31

// Motor Ports Limit Switch Flags
#define PLIM_1		M7501
#define PLIM_2		M7502
#define PLIM_3		M7503
#define PLIM_4		M7504
#define PLIM_5		M7505
#define PLIM_6		M7506
#define PLIM_7		M7507
#define PLIM_8		M7508

#define MLIM_1		M7511
#define MLIM_2		M7512
#define MLIM_3		M7513
#define MLIM_4		M7514
#define MLIM_5		M7515
#define MLIM_6		M7516
#define MLIM_7		M7517
#define MLIM_8		M7518

// Motor Ports Home Inputs
#define HOME_1		M7521
#define HOME_2		M7522
#define HOME_3		M7523
#define HOME_4		M7524
#define HOME_5		M7525
#define HOME_6		M7526
#define HOME_7		M7527
#define HOME_8		M7528

// Motor Ports Amplifier Faults Inputs
//#define FAULT_1		M7531
//#define FAULT_2		M7532
//#define FAULT_3		M7533
//#define FAULT_4		M7534
#define FAULT_5		M7535
#define FAULT_6		M7536
#define FAULT_7		M7537
#define FAULT_8		M7538

// Motor Port Flag Inputs
#define USER_1		M7541
#define USER_2		M7542
#define USER_3		M7543
#define USER_4		M7544
#define USER_5		M7545
#define USER_6		M7546
#define USER_7		M7547
#define USER_8		M7548

#define FLAG_W1		M7551
#define FLAG_W2		M7552
#define FLAG_W3		M7553
#define FLAG_W4		M7554
#define FLAG_W5		M7555
#define FLAG_W6		M7556
#define FLAG_W7		M7557
#define FLAG_W8		M7558

#define FLAG_V1		M7561
#define FLAG_V2		M7562
#define FLAG_V3		M7563
#define FLAG_V4		M7564
#define FLAG_V5		M7565
#define FLAG_V6		M7566
#define FLAG_V7		M7567
#define FLAG_V8		M7568

#define FLAG_U1		M7571
#define FLAG_U2		M7572
#define FLAG_U3		M7573
#define FLAG_U4		M7574
#define FLAG_U5		M7575
#define FLAG_U6		M7576
#define FLAG_U7		M7577
#define FLAG_U8		M7578

#define FLAG_T1		M7581
#define FLAG_T2		M7582
#define FLAG_T3		M7583
#define FLAG_T4		M7584
#define FLAG_T5		M7585
#define FLAG_T6		M7586
#define FLAG_T7		M7587
#define FLAG_T8		M7588

// ******************************************
// Multiplex Outputs
// ******************************************

#define Q40_0	MP6_B0
#define Q40_1	MP6_B1
#define Q40_2	MP6_B2
#define Q40_3	MP6_B3
#define Q40_4	MP6_B4
#define Q40_5	MP6_B5
#define Q40_6	MP6_B6
#define Q40_7	MP6_B7

#define Q41_0	MP6_B8
#define Q41_1	MP6_B9
#define Q41_2	MP6_B10
#define Q41_3	MP6_B11
#define Q41_4	MP6_B12
#define Q41_5	MP6_B13
#define Q41_6	MP6_B14
#define Q41_7	MP6_B15

#define Q42_0	MP6_B16
#define Q42_1	MP6_B17
#define Q42_2	MP6_B18
#define Q42_3	MP6_B19
#define Q42_4	MP6_B20
#define Q42_5	MP6_B21
#define Q42_6	MP6_B22
#define Q42_7	MP6_B23

#define Q43_0	MP6_B24
#define Q43_1	MP6_B25
#define Q43_2	MP6_B26
#define Q43_3	MP6_B27
#define Q43_4	MP6_B28
#define Q43_5	MP6_B29
#define Q43_6	MP6_B30
#define Q43_7	MP6_B31

#define Q44_0	MP14_B0
#define Q44_1	MP14_B1
#define Q44_2	MP14_B2
#define Q44_3	MP14_B3
#define Q44_4	MP14_B4
#define Q44_5	MP14_B5
#define Q44_6	MP14_B6
#define Q44_7	MP14_B7

#define Q45_0	MP14_B8
#define Q45_1	MP14_B9
#define Q45_2	MP14_B10
#define Q45_3	MP14_B11
#define Q45_4	MP14_B12
#define Q45_5	MP14_B13
#define Q45_6	MP14_B14
#define Q45_7	MP14_B15

#define Q46_0	MP14_B16
#define Q46_1	MP14_B17
#define Q46_2	MP14_B18
#define Q46_3	MP14_B19
#define Q46_4	MP14_B20
#define Q46_5	MP14_B21
#define Q46_6	MP14_B22
#define Q46_7	MP14_B23

#define Q47_0	MP14_B24
#define Q47_1	MP14_B25
#define Q47_2	MP14_B26
#define Q47_3	MP14_B27
#define Q47_4	MP14_B28
#define Q47_5	MP14_B29
#define Q47_6	MP14_B30
#define Q47_7	MP14_B31

// ******************************************
// Direct Digital Outputs
// ******************************************

//Direction control for Direct Outputs I/O 00-07
#define ContIn3		M36
#define ContInBuf3	M37

//Direction control for Direct Outputs I/O 08-15
#define ContIn4		M38
#define ContInBuf4	M39

#define O_0		M16
#define O_1		M17
#define O_2		M18
#define O_3		M19
#define O_4		M20
#define O_5		M21
#define O_6		M22
#define O_7		M23

#define O_8		M24
#define O_9 	M25
#define O_10	M26
#define O_11	M27
#define O_12	M28
#define O_13	M29
#define O_14	M30
#define O_15	M31

#ifndef __cplusplus
// *************************************************
// M Variable Address Assignment
// *************************************************

// Motor Ports Limit Switch Flags
PLIM_1->X:$078000,17,1
PLIM_2->X:$078008,17,1
PLIM_3->X:$078010,17,1
PLIM_4->X:$078018,17,1
PLIM_5->X:$078100,17,1
PLIM_6->X:$078108,17,1
PLIM_7->X:$078110,17,1
PLIM_8->X:$078118,17,1

MLIM_1->X:$078000,18,1
MLIM_2->X:$078008,18,1
MLIM_3->X:$078010,18,1
MLIM_4->X:$078018,18,1
MLIM_5->X:$078100,18,1
MLIM_6->X:$078108,18,1
MLIM_7->X:$078110,18,1
MLIM_8->X:$078118,18,1

// Motor Ports Home Inputs
HOME_1->X:$078000,16,1
HOME_2->X:$078008,16,1
HOME_3->X:$078010,16,1
HOME_4->X:$078018,16,1
HOME_5->X:$078100,16,1
HOME_6->X:$078108,16,1
HOME_7->X:$078110,16,1
HOME_8->X:$078118,16,1

// Motor Ports Amplifier Faults Inputs
FAULT_1->X:$078000,15,1
FAULT_2->X:$078008,15,1
FAULT_3->X:$078010,15,1
FAULT_4->X:$078018,15,1
FAULT_5->X:$078100,15,1
FAULT_6->X:$078108,15,1
FAULT_7->X:$078110,15,1
FAULT_8->X:$078118,15,1

// Motor Ports Flag Inputs
USER_1->X:$078000,19,1
USER_2->X:$078008,19,1
USER_3->X:$078010,19,1
USER_4->X:$078018,19,1
USER_5->X:$078100,19,1
USER_6->X:$078108,19,1
USER_7->X:$078110,19,1
USER_8->X:$078118,19,1

FLAG_W1->X:$078000,20,1
FLAG_W2->X:$078008,20,1
FLAG_W3->X:$078010,20,1
FLAG_W4->X:$078018,20,1
FLAG_W5->X:$078100,20,1
FLAG_W6->X:$078108,20,1
FLAG_W7->X:$078110,20,1
FLAG_W8->X:$078118,20,1

FLAG_V1->X:$078000,21,1
FLAG_V2->X:$078008,21,1
FLAG_V3->X:$078010,21,1
FLAG_V4->X:$078018,21,1
FLAG_V5->X:$078100,21,1
FLAG_V6->X:$078108,21,1
FLAG_V7->X:$078110,21,1
FLAG_V8->X:$078118,21,1

FLAG_U1->X:$078000,22,1
FLAG_U2->X:$078008,22,1
FLAG_U3->X:$078010,22,1
FLAG_U4->X:$078018,22,1
FLAG_U5->X:$078100,22,1
FLAG_U6->X:$078108,22,1
FLAG_U7->X:$078110,22,1
FLAG_U8->X:$078118,22,1

FLAG_T1->X:$078000,23,1
FLAG_T2->X:$078008,23,1
FLAG_T3->X:$078010,23,1
FLAG_T4->X:$078018,23,1
FLAG_T5->X:$078100,23,1
FLAG_T6->X:$078108,23,1
FLAG_T7->X:$078110,23,1
FLAG_T8->X:$078118,23,1


//Direct Digital Inputs
I30_0->Y:$078400,0	// I/O00
I30_1->Y:$078400,1	// I/O01
I30_2->Y:$078400,2	// I/O02
I30_3->Y:$078400,3	// I/O03
I30_4->Y:$078400,4	// I/O04
M5->Y:$078400,5		// I/O05
M6->Y:$078400,6		// I/O06
M7->Y:$078400,7		// I/O07
M8->Y:$078400,8		// I/O08 Data Line; J3 Pin 9
M9->Y:$078400,9		// I/O09 Data Line; J3 Pin 10
M10->Y:$078400,10		// I/O10 Data Line; J3 Pin 11
M11->Y:$078400,11		// I/O11 Data Line; J3 Pin 12
M12->Y:$078400,12		// I/O12 Data Line; J3 Pin 13
M13->Y:$078400,13		// I/O13 Data Line; J3 Pin 14
M14->Y:$078400,14		// I/O14 Data Line; J3 Pin 15
M15->Y:$078400,15		// I/O15 Data Line; J3 Pin 16

//Direct Digital Outputs
M16->Y:$078400,16		// I/O16 Data Line; J3 Pin 17
M17->Y:$078400,17		// I/O17 Data Line; J3 Pin 18
M18->Y:$078400,18		// I/O18 Data Line; J3 Pin 19
M19->Y:$078400,19		// I/O19 Data Line; J3 Pin 20
M20->Y:$078400,20		// I/O20 Data Line; J3 Pin 21
M21->Y:$078400,21		// I/O21 Data Line; J3 Pin 22
M22->Y:$078400,22		// I/O22 Data Line; J3 Pin 23
M23->Y:$078400,23		// I/O23 Data Line; J3 Pin 24
M24->Y:$078401,0		// I/O24 Data Line; J3 Pin 25
M25->Y:$078401,1		// I/O25 Data Line; J3 Pin 26
M26->Y:$078401,2		// I/O26 Data Line; J3 Pin 27
M27->Y:$078401,3		// I/O27 Data Line; J3 Pin 28
M28->Y:$078401,4		// I/O28 Data Line; J3 Pin 29
M29->Y:$078401,5		// I/O29 Data Line; J3 Pin 30
M30->Y:$078401,6		// I/O30 Data Line; J3 Pin 31
M31->Y:$078401,7		// I/O31 Data Line; J3 Pin 32

//0-7 Bit Direction Control Digital I/O Registers
M32->X:$078400,0,8	// Direction control for I/O00 to I/O07
M33->Y:$070800,0		// Buffer direction control for I/O00 to I/O07

//8-15 Bit Direction Control Digital I/O Registers
M34->X:$078400,8,8	// Direction control for I/O08 to I/O15
M35->Y:$070800,1		// Buffer direction control for I/O08 to I/O15

//16-23 Bit Direction Control Digital I/O Registers
M36->X:$078400,16,8	// Direction control for I/O16 to I/O23
M37->Y:$070800,2		// Buffer direction control for I/O16 to I/O23

//24-31 Bit Direction Control Digital I/O Registers
M38->X:$078401,0,8	// Direction control for I/O24 to I/O31
M39->Y:$070800,3		// Buffer direction control for I/O24 to I/O31


#endif

#endif